RETURN CREATEOBJECT('XlsClass')

DEFINE CLASS XlsClass AS CUSTOM
	loXls	= .F.
	loSheet=.F.
	loDocument	= .F.
	lcDecPoint='.'

	FUNCTION INIT
		WITH THIS
			llOK=.T.
			TRY
				.loXls=GETOBJECT(,"EXCEL.APPLICATION")
			CATCH TO loErr
				llOK=.F.
			FINALLY
			ENDTRY

			IF ! llOK
				llOK=.T.
				TRY
					.loXls=CREATEOBJECT("EXCEL.APPLICATION")
				CATCH TO loErr
					llOK=.F.
				FINALLY
				ENDTRY
			ENDIF
			IF ! llOK
				Warn(loErr.Message," - Excel  .")
				RETURN .F.
			ENDIF
			WITH .loXls
				.VISIBLE=.F.
				TRY
					.APPLICATION.DisplayFullScreen = .T.
				CATCH
				ENDTRY
				TRY
					.APPLICATION.DisplayFullScreen = .F.
				CATCH
				ENDTRY
				.VISIBLE=.F.
				.APPLICATION.ReferenceStyle = 1
			ENDWITH

		ENDWITH
		RETURN .T.

	FUNCTION activeSheet
		RETURN THIS.loDocument.activeSheet

	FUNCTION AddSheet
		LPARAMETERS lcName
		WITH THIS.loDocument
			IF TYPE([.sheets(lcName))]) # 'O'
				loWorkSheet=.Sheets.ADD
				loWorkSheet.NAME = lcName
			ELSE
				loWorkSheet=.Sheets(lcName)
			ENDIF
		ENDWITH
		RETURN loWorkSheet

	FUNCTION AutoFitRows
		LPARAMETERS loSheet,ln1,ln2
* Call:	AutoFitRows(loSheet,lcRange)
* 		AutoFitRows(loSheet,lnRow1,lnRow2)
		loSheet=THIS.SelectSheet(loSheet)
		IF TYPE('ln1')='C'
			lcRange=ln1
		ELSE
			lcRange=ALLTRIM(STR(ln1))+':'+ALLTRIM(STR(ln2))
		ENDIF
		WITH loSheet.ROWS(lcRange)
			.EntireRow.AUTOFIT
		ENDWITH

	FUNCTION CloseDocument
		LPARAMETERS lcName
		WITH THIS
			IF EMPTY(lcName)
				.loDocument.CLOSE()
			ELSE
				IF TYPE('.loXls.Workbooks(lcName+".xls")')='O'
					.loXls.Workbooks(lcName+".xls").CLOSE
				ENDIF
			ENDIF
		ENDWITH

	FUNCTION CopyArray
		PARA lcSheet,lnLine,lnCol,aX,llClear,lcFormat

*: lcSheet - XLS sheet name
*:	lnLine, lnCol - XLS Cell ID. Started copying from this cell.
*: aX - array to copy
*: llClear - logical. If .t. cells from lnLine,lnCol in xls sheet to be cleared before copying.
		LOCAL i, j, lcType, llOneDim, lnCols, lnLines, loSheet

		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.activeSheet,loSheet)
		lnLines=ALEN(aX,1)
		lnCols=ALEN(aX,2)
		llOneDim = lnCols=0
		lnCols=MAX(1,lnCols)

		lcYes=LANG('','')
		lcNo=LANG('ͳ','')
		FOR j=1 TO lnCols
			lcType=TYPE("aX(1,j)")
			DO CASE
				CASE lcType="L"
					FOR i=1 TO lnLines
						aX(i,j)= IIF(aX(i,j),lcYes,lcNo)
					NEXT
				CASE lcType="D"
					FOR i=1 TO lnLines
						aX(i,j)= DTOC(aX(i,j))
					NEXT
				CASE lcType="T"
					FOR i=1 TO lnLines
						aX(i,j) = TTOC(aX(i,j))
					NEXT
*			CASE ISNULL(aX(i,j))
*						aX(i,j)=''
			ENDCASE
		NEXT
		IF llClear
			lnLastLine=0
			lnLastCol=0
			THIS.LastCell( loSheet, @lnLastLine, @lnLastCol)
			lo=THIS.SelectRange( loSheet,lnLine,lnCol,lnLastLine, lnLastCol)
			lo.ClearContents
		ENDIF

		lcRange=Range_N2C(lnLine,lnCol)
		lcRange=lcRange+':'+Range_C2N(lcRange,,,lnLines-1,lnCols-1)
		loSheet.RANGE(lcRange).VALUE = ArrayPasser('Ax')

		IF !EMPTY(lcFormat)
			loSheet.RANGE(lcRange).SELECT
			THIS.FORMAT(lcSheet,lcFormat)
		ENDIF
		RETU
		DIME aX(1)

	FUNCTION CopyRows
		LPARAMETERS loSheet,ln1,ln2
		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.activeSheet,loSheet)
		lcRange=IIF(TYPE('ln1')='C',ln1,ALLTRIM(STR(ln1))+':'+ALLTRIM(STR(EVL(ln2,ln1))))
		loRange = loSheet.ROWS(lcRange).COPY

	FUNCTION CopyRowsTo
		LPARAMETERS loSheet,lnFrom1,lnFrom2, lnTo1, lnTo2
* CopyRowsTo(loSheet,lnFrom1,lnFrom2, lnTo1, lnTo2)
		lcTo = ALLTRIM(STR(lnTo1))+':'+ALLTRIM(STR(lnTo2))
		THIS.InsertRows(loSheet,lnTo1,lnTo2)
		lcFrom=ALLTRIM(STR(lnFrom1))+':'+ALLTRIM(STR(lnFrom2))
		loXl.loXls.ROWS(lcFrom).COPY (loXl.loXls.ROWS(lcTo))

	FUNCTION CopySheet
		LPARAMETERS loSheet
		loSheet.COPY( , loSheet )
		RETURN THIS.loDocument.activeSheet

	FUNCTION cutcopymode
		LPARAMETERS llMode
		THIS.loXls.cutcopymode=llMode

	FUNCTION DeleteRows
		LPARAMETERS ln1,ln2
		IF EMPTY(ln2)
			ln2=ln1
		ENDIF
		THIS.loDocument.activeSheet.ROWS(ALLTRIM(STR(ln1))+':'+ALLTRIM(STR(ln2))).DELETE

	FUNCTION DeleteSheet
		LPARAMETERS lcSheet
		IF TYPE('lcSheet')='O'
			lcSheet=lcSheet.NAME
		ENDIF
		THIS.loXls.Sheets(lcSheet).DELETE

	FUNCTION DisplayAlerts
		LPARAMETERS llDisplay
		THIS.loXls.DisplayAlerts = llDisplay
		RETURN .T.

	FUNCTION FORMAT
		LPARA lcSheet,lcFormat,lnLeft1,lnTop1, lnLeft2,lnTop2
*	lcFormat: 1-  C - ., R- 
*	 		  2-  C - .
*	 		  3-  Y/N -  
*	 		  4-  1 -   
*	 		  4-  2 -   
*			5,6-  font size
*	 		  7-  Y/N - font bold
*			8,9-  font Color (2-,3-,5-,10-,15 )
*		  10,11-   
		LOCAL lcOnError, lnInsideWeight, loSheet

		lcFormat=IIF(EMPTY(lcFormat) OR TYPE("lcFormat")#"C","",	;
			CHRT(UPPER(lcFormat),"+-","CYYCNN"))+SPACE(30)
		IF TYPE('lcSheet')='C'
			loSheet = THIS.SelectSheet(lcSheet)
		ELSE
			loSheet=lcSheet
		ENDIF
		IF !EMPTY(lnLeft1)
			loSheet.RANGE(loSheet.cells(lnLeft1,lnTop1),loSheet.cells(lnLeft2,lnTop2)).SELECT
		ENDIF
		WITH THIS.loXls.SELECTION
			IF SUBS(lcFormat,1,1)$"cC"
				.HorizontalAlignment = -4108
			ENDIF
			IF SUBS(lcFormat,1,1)$"rR"
				.HorizontalAlignment = -4152
			ENDIF
			IF SUBS(lcFormat,2,1)$"cC"
				.VerticalAlignment =-4108
			ENDIF
			IF SUBS(lcFormat,2,1)$"tT"
				.VerticalAlignment =-4160
			ENDIF
			IF SUBS(lcFormat,3,1)="Y"
				.WrapText = .T.
			ENDIF
			IF SUBS(lcFormat,3,1)="N"
				.WrapText = .F.
			ENDIF
			IF SUBS(lcFormat,4,1)$"12"
				lnInsideWeight=VAL(SUBS(lcFormat,4,1))
				.BorderAround(,2)
				TRY
					.BORDERS(11).Weight = lnInsideWeight
					.BORDERS(12).Weight = lnInsideWeight
				CATCH
				ENDTRY
			ENDIF
			IF !EMPTY(SUBS(lcFormat,5,2)) AND !ISALPHA(SUBS(lcFormat,5,2))		&& Font Size
				.FONT.SIZE=VAL(SUBS(lcFormat,5,2))
			ENDIF
			IF SUBS(lcFormat,7,1) $ "YN"		&& Font Bold
				.FONT.Bold=SUBS(lcFormat,7,1)="Y"
			ENDIF
			IF !EMPTY(SUBS(lcFormat,8,2)) AND !ISALPHA(SUBS(lcFormat,8,2))		&& Font Size
				.FONT.ColorIndex=VAL(SUBS(lcFormat,8,2))
			ENDIF
			IF !EMPTY(SUBS(lcFormat,10,2)) AND !ISALPHA(SUBS(lcFormat,10,2))	&& Font Size
				.Interior.ColorIndex=VAL(SUBS(lcFormat,10,2))
			ENDIF
		ENDWITH

	FUNCTION GetActiveCell
		LPARAMETERS loSheet, llRange
		lo=loSheet.APPLICATION.ActiveCell
		RETURN IIF(llRange,Range_N2C(lo.ROW,lo.COLUMN),lo)

	FUNCTION GetCellFormula
		LPARAMETERS loSheet, lnRow, lnColumn
		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.activeSheet,loSheet)
		RETURN loSheet.cells(lnRow,lnColumn).Formula

	FUNCTION GetCellValue
		LPARAMETERS loSheet, lnRow, lnColumn
		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.activeSheet,loSheet)
		RETURN loSheet.cells(lnRow,lnColumn).VALUE

	FUNCTION GetPaint
		LPARAMETERS loSheet,lnLine1,lnCol1,lnLine2,lnCol2
		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.activeSheet,loSheet)
		IF TYPE('lnLine1')='C'
			lcRange=lnLine1
		ELSE
			lnLine1=EVL(lnLine1,1)
			lnCol1=EVL(lnCol1,1)
			lnLine2=EVL(lnLine2,lnLine1)
			lnCol2=EVL(lnCol2,lnCol1)
TEXT TO lcRange
<<Num2Lat(lnCol1)>><<int(lnLine1)>>:<<Num2Lat(lnCol2)>><<int(lnLine2)>>
ENDTEXT
		ENDIF
		lo=THIS.SelectRange(loSheet,lcRange)
		lo.COPY
		RETU

	FUNCTION InsertColumns
		LPARAMETERS loSheet,ln1,ln2
		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.activeSheet,loSheet)
		lcRange=IIF(TYPE('ln1')='C',ln1,num2lat(ln1)+':'+num2lat(EVL(ln2,ln1)))
		loSheet.COLUMNS(lcRange).INSERT(-4161)

	FUNCTION InsertRight
		LPARAMETERS loSheet,lnLine,lnCol, lnCount
* Call:	InsertRight(loSheet,lnLine,lnCol, lnCount)
		IF TYPE('loSheet')='C' AND !EMPTY(loSheet)
			loSheet=THIS.SelectSheet(loSheet)
		ENDIF
		IF TYPE('loSheet')='O'
			loSheet=THIS.activeSheet()
		ENDIF

		IF TYPE('lnLine')='C'
			loTargetCell=THIS.SelectRange(loSheet,lnLine)
		ELSE
			loTargetCell=THIS.SelectRange(loSheet,lnLine,lnCol,lnLine,lnCol+lnCount)
		ENDIF
		loTargetCell.INSERT (-4161)

	FUNCTION InsertRows
		LPARAMETERS loSheet,ln1,ln2
		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.activeSheet,loSheet)
		lcRange=IIF(TYPE('ln1')='C',ln1,ALLTRIM(STR(ln1))+':'+ALLTRIM(STR(EVL(ln2,ln1))))
		loSheet.ROWS(lcRange).INSERT(-4121,1)

	FUNCTION IsSheetVisible
		LPARAMETERS loSheet
		RETURN loSheet.VISIBLE#0

	FUNCTION LastCell
		LPARAMETERS loSheet, lnRows, lnColumns
* LastCell(loSheet, lnRows, lnColumns)
		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.activeSheet,loSheet)
		loLast=loSheet.cells(1,1).SpecialCells(11)
		lnRows=loLast.ROW
		lnColumns=loLast.COLUMN

	FUNCTION NumberFormat
		LPARAMETERS loSheet, lcRange, lcType, lnDecimals
		DO CASE
			CASE lcType='C'
				lcFormat='@'
			CASE lcType='N'
				lcFormat=IIF(lnDecimals=0,'0','0.'+REPLICATE('0',lnDecimals))
			OTHERWISE
				RETURN
		ENDCASE
		loSheet.RANGE(lcRange).NumberFormat=lcFormat

	FUNCTION OpenDocument
		LPARAMETERS lcWorkBook
		WITH THIS
			IF EMPTY(lcWorkBook)
				.loXls.APPLICATION.Workbooks.ADD
				RETU
			ENDIF
			llOpened=.F.
			lcThisBook=lcWorkBook+IIF(RIGHT(UPPER(lcWorkBook),4) = '.XLS','',".xls")

			FOR EACH loEachBook IN .loXls.Workbooks
				IF UPPER(loEachBook.NAME)=lcThisBook AND !llRecreate
					llOpened=.T.
					THIS.loDocument=loEachBook
					.loXls.WINDOWS(lcThisBook).ACTIVATE
				ENDIF
			NEXT
			IF llOpened
				RETU
			ENDIF

			WITH .loXls
				DO CASE
					CASE FILE(lcThisBook)
						lcFullPath=FULLPATH(lcThisBook)
						loBook=.Workbooks.OPEN(lcFullPath)
					CASE  llRecreate
						IF ':'$lcWorkBook OR '\'$lcWorkBook
							lcPath=SUBSTR(lcWorkBook,1,MAX(RAT(':',lcWorkBook),RAT('\',lcWorkBook)))
							lcWorkBook=SUBSTR(lcWorkBook,LEN(lcPath)+1)
						ELSE
							lcPath = SET("default")+CURDIR()+"maket\"
						ENDIF
						lcJustDir=lcPath+lcWorkBook
						lcJustDir=IIF('\'$lcJustDir,LEFT(lcJustDir,RAT('\',lcJustDir)),'')
						IF !EMPTY(lcJustDir) AND !DIRECTORY(lcJustDir)
							MD (lcJustDir)
						ENDIF
						IF TYPE('.Workbooks(lcWorkBook+".xls")')='O'
							.Workbooks(lcWorkBook+".xls").CLOSE
						ENDIF

						loBook=.Workbooks.ADD
						loBook.SAVEAS(lcPath+lcWorkBook+".xls")
					OTHER
						lcPath = UPPER(SYS(2023))
						IF !'\EXCEL' $ lcPath AND !'EXCEL\' $ UPPER(lcWorkBook)
							lcPath = lcPath +"\Excel\"
						ENDIF
						IF !DIRECTORY(lcPath)
							MD (lcPath)
						ENDIF
						lcPath=lcPath+IIF(RIGHT(lcPath,1)='\','','\')
						loBook=.Workbooks.ADD
						loBook.SAVEAS(lcPath+lcWorkBook+".xls")
				ENDCASE
				THIS.loDocument=loBook
				lcWorkBook=IIF('\'$lcWorkBook,SUBS(lcWorkBook,RAT('\',lcWorkBook)+1),lcWorkBook)
				IF ATC(".xls",lcWorkBook)=0
					lcWorkBook=lcWorkBook+".xls"
				ENDIF
				.WINDOWS(lcWorkBook).VISIBLE = .T.
			ENDWITH
			.loXls.ActiveWindow.WINDOWSTATE = -4137
			.loXls.ActiveWindow.DisplayFormulas = .F.
			PUBLIC gcExcelPoint
			TRY
				.loXls.UseSystemSeparators = .F.
				.loXls.DecimalSeparator = "."
				gcExcelPoint='.'
			CATCH
				gcExcelPoint = DecSymbol()
			ENDTRY
			THIS.Zeros()
		ENDWITH

	FUNCTION PageBreak
		LPARAMETERS loSheet, lnLine
		loSheet.HPageBreaks.ADD(loSheet.RANGE(loSheet.cells(lnLine,1),loSheet.cells(lnLine,1)))

	FUNCTION PageOrientation
		LPARAMETERS lnOrientation
		LOCAL loSheet
		lnOrientation=EVL(lnOrientation,1)
		loSheet=THIS.activeSheet()
		loSheet.PageSetup.ORIENTATION = lnOrientation

	FUNCTION PasteCells
		LPARAMETERS loSheet,lnLine1,lnCol1

		IF TYPE('loSheet')#'O'
			loSheet=THIS.activeSheet()
		ENDIF
		lcRange=IIF(VARTYPE(lnLine1)='C',lnLine1,num2lat(lnCol1)+ALLTRIM(STR(lnLine1)))
		loSheet.RANGE(lcRange).SELECT
		loSheet.Paste

	FUNCTION PasteFromArray
		PARAMETERS loSheet,laPasteArray,lnLine1,lnCol1,lnLine2,lnCol2
		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.activeSheet,loSheet)
		IF TYPE('ln1')='C'
			lcRange=ln1+IIF(':'$ln1,'',':'+Range_C2N(ln1,,,ALEN(laPasteArray,1),ALEN(laPasteArray,2)))
		ELSE
			lcRange=ALLTRIM(STR(ln1))+':'+ALLTRIM(STR(EVL(ln2,ln1)))
		ENDIF
		loSheet.RANGE(lcRange).VALUE=ArrayPasser('laPasteArray')

	FUNCTION PasteRows
		LPARAMETERS loSheet,ln1,ln2
* Call:	PasteRows(loSheet,lcRange)
* 		PasteRows(loSheet,lnRow1,lnRow2)
		loSheet=THIS.SelectSheet(loSheet)
		IF TYPE('ln1')='C'
			lcRange=ln1
		ELSE
			lcRange=ALLTRIM(STR(ln1))+':'+ALLTRIM(STR(ln2))
		ENDIF
		WITH loSheet.ROWS(lcRange)
			.INSERT(-4121)
*			.EntireRow.AUTOFIT
			THIS.loXls.cutcopymode=.F.
		ENDWITH

	FUNCTION RenameSheet
		LPARAMETERS lcName
		THIS.loDocument.activeSheet.NAME=lcName

	FUNCTION SAVEAS
		LPARAMETERS lcNewName
		lcNewName=IIF(ATC(".xls",lcNewName)=0,lcNewName,lcNewName+".xls")
		THIS.loDocument.SAVEAS(lcNewName)

	FUNCTION SelectColumn
		LPARAMETERS loSheet,lnColumn
		LOCAL loCol,lcColumn
		lcColumn=num2lat(lnColumn)
		loSheet=IIF(TYPE('loSheet')='O',loSheet,THIS.activeSheet())
		loCol=loSheet.COLUMNS(lcColumn+':'+lcColumn)
		loCol.SELECT
		RETURN loCol

	FUNCTION SelectRange
		LPARAMETERS loSheet,lnLine1,lnCol1,lnLine2,lnCol2
		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.activeSheet,loSheet)
		loSheet.SELECT
		IF TYPE('lnLine1')='C'
			IF ISDIGIT(lnLine1)
				lo=loSheet.ROWS(lnLine1)
				lo.SELECT
				RETURN lo
			ENDIF
			lcRange=lnLine1
		ELSE
			lnLine1=EVL(lnLine1,1)
			lnCol1=EVL(lnCol1,1)
			lnLine2=EVL(lnLine2,lnLine1)
			lnCol2=EVL(lnCol2,lnCol1)
TEXT TO lcRange
<<Num2Lat(lnCol1)>><<int(lnLine1)>>:<<Num2Lat(lnCol2)>><<int(lnLine2)>>
ENDTEXT
		ENDIF
		lo=loSheet.RANGE(lcRange)
		lo.SELECT
		RETURN lo

	FUNCTION SelectSheet
		LPARAMETERS lcsheetName
		IF TYPE('lcsheetName')='O'
			lcsheetName=lcsheetName.NAME
		ENDIF
		THIS.loDocument.Sheets(lcsheetName).SELECT
		RETURN THIS.loDocument.activeSheet

	FUNCTION SetActiveCell
		LPARAMETERS loSheet, loCell
		loCell.SELECT

	FUNCTION SetCellFormula
		LPARAMETERS loSheet, lnRow, lnColumn, luValue
		RETURN loSheet.cells(lnRow,lnColumn).Formula=luValue

	FUNCTION SetCellValue
		LPARAMETERS loSheet, lnRow, lnColumn, luValue
		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.activeSheet,loSheet)
		loSheet.cells(lnRow,lnColumn).VALUE=luValue

	FUNCTION SetColumnAutoWidth
		LPARAMETERS lnColumn1,lnColumn2
		LOCAL loSheet
		loSheet=THIS.activeSheet()
		lcRange=num2lat(lnColumn1)+':'+num2lat(EVL(lnColumn2,lnColumn1))
		loSheet.COLUMNS(lcRange).EntireColumn.AUTOFIT
		RETURN

	FUNCTION SetColumnWidth
		LPARAMETERS lnColumn, lnWidth, lnXlsKoef
		LOCAL lc,loSheet
		IF TYPE('lnWidth')#'N'
			RETURN
		ENDIF
		lnXlsKoef=EVL(lnXlsKoef,0.86)
		lc=num2lat(lnColumn)
		loSheet=THIS.activeSheet()
		loSheet.COLUMNS(lc+":"+lc).COLUMNWIDTH =lnWidth*lnXlsKoef

	FUNCTION SetDocumentVisible
		LPARAMETERS llVisible
		WITH THIS.loXls
			.ScreenUpdating=llVisible
			.INTERACTIVE=llVisible
			.VISIBLE=llVisible
		ENDWITH
		this.loDocument.Saved=llVisible

	FUNCTION SetFontSize
		LPARAMETERS lcRange, lnFontSize
		LOCAL loSheet
		loSheet=THIS.activeSheet()
		loSheet.RANGE(lcRange).FONT.SIZE=m.lnFontSize

	FUNCTION SetPaint
		LPARAMETERS loSheet,lnLine1,lnCol1,lnLine2,lnCol2
		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.activeSheet,loSheet)
		IF TYPE('lnLine1')='O'
			lnLine1.pastespecial(-4122,-4142)
			RETURN
		ENDIF
		IF TYPE('lnLine1')='C'
			loSheet.RANGE(lnLine1).pastespecial(-4122,-4142)
			RETURN
		ENDIF
		lo=THIS.SelectRange(loSheet,lnLine1,lnCol1,lnLine2,lnCol2)
		lo.pastespecial(-4122,-4142)
		RETURN

	FUNCTION SetRowAutoHeight
		LPARAMETERS lnRow1,lnRow2
		lcRange=ALLTRIM(STR(lnRow1))+':'+ALLT(STR(EVL(lnRow2,lnRow1)))
		loSheet=THIS.activeSheet()
		loSheet.ROWS(lcRange).EntireRow.AUTOFIT

	FUNCTION SetSheetVisible
		LPARAMETERS loSheet, llVisible
		loSheet.VISIBLE=llVisible

	FUNCTION SheetCount
		RETURN THIS.loDocument.Sheets.COUNT

	FUNCTION SheetName
		LPARAMETERS loSheet
		RETURN loSheet.NAME

	FUNCTION Zeros
		LPARAMETERS llShow
		llShow=IIF(EMPTY(llShow) OR TYPE("llShow") # "L",.F.,llShow)

		FOR EACH loSheet IN THIS.loXls.Sheets
			IF loSheet.VISIBLE=0
				LOOP
			ENDIF
			loSheet.SELECT
			goXls.ActiveWindow.DisplayZeros=llShow
		NEXT
	FUNCTION FitToPagesWide
		LPARAMETERS lnPages
		LOCAL loSheet
		loSheet=THIS.activeSheet()
		loSheet.PageSetup.FitToPagesWide = lnPages

ENDDEFINE
