RETURN CREATEOBJECT('ooClass')

DEFINE CLASS ooClass AS CUSTOM
	loMgr	= .F.
	loDesktop=.F.
	loDocument	= .F.
	loCoreReflection = .F.
	loProperty	= .F.
	loDispatcher = .F.
	lnDX = GetDeviceCaps(GetDC(GetActiveWindow()),88)
	lcDecPoint='.'
	DIMENSION laProps(6)
	FUNCTION INIT
		LOCAL lnLine, loProperty
		WITH THIS
			.loMgr = CREATEOBJECT("com.sun.star.ServiceManager")
			IF TYPE('.loMgr') # "O"
				RETURN .F.
			ENDIF
			.loDesktop = .loMgr.createInstance("com.sun.star.frame.Desktop")
			.loDispatcher = .loMgr.createInstance("com.sun.star.frame.DispatchHelper")
			.loCoreReflection = .loMgr.createInstance("com.sun.star.reflection.CoreReflection")
			WITH .loCoreReflection.forName("com.sun.star.beans.PropertyValue")
				FOR lnLine=1 TO 6
					loProperty =CREATEOBJECT( "Empty" )
					.CREATEOBJECT(@loProperty)
					THIS.laProps(lnLine)=loProperty
				NEXT
			ENDWITH
			RELEASE loProperty
			COMARRAY(.loDesktop,10)
*Set objFrame = StarDesktop.ActiveFrame 
*Set objWindow = objFrame.GetContainerWindow 
*objWindow.SetVisible False 

		ENDWITH
		RETURN .T.

	FUNCTION ActiveSheet
		RETURN THIS.loDocument.getCurrentController().getActiveSheet()

	FUNCTION AddSheet
		LPARAMETERS lcName
		WITH THIS.loDocument
			IF TYPE([.getByName(lcName))]) = 'O'
				loWorkSheet=.getbyName(lcName)
			ELSE
				loWorkSheet=.getSheets().insertNewByName(lcName,0)
			ENDIF
		ENDWITH
		RETURN loWorkSheet


	FUNCTION AutoFitRows
		LPARAMETERS loSheet,ln1,ln2


	FUNCTION CloseDocument
		LPARAMETERS lcName
		WITH THIS
			IF EMPTY(lcName)
				.loDocument.CLOSE(.T.)
			ELSE
				lcName=LOWER(lcName)
				loComponents=.loDesktop.getcomponents()
				loDocs = loComponents.createEnumeration()
				DO WHILE loDocs.hasMoreElements()
					loDoc = loDocs.nextElement()
					IF TYPE([loDoc.SupportsService("com.sun.star.sheet.SpreadsheetDocument")])='L' AND ;
							loDoc.SupportsService("com.sun.star.sheet.SpreadsheetDocument")
						lcUrl=LOWER(loDoc.geturl)
						lnPos=RAT('/',lcUrl)
						IF lnPos>0
							lcUrl=SUBSTR(lcUrl,lnPos+1)
						ENDIF
						IF lcUrl==lcName
							loDoc.CLOSE(.T.)
						ENDIF
					ENDIF
				ENDDO
			ENDIF
		ENDWITH


	FUNCTION ConvertToURL( lcFilename )
		RETURN "file://" + CHRTRAN( IIF (LEFT( lcFilename, 1 ) # "/","/","")+lcFilename, "\", "/" )


	FUNCTION CopyArray
		LPARA lcSheet,lnLine,lnCol,aX,llClear,lcFormat
		LOCAL i, j, 	;
			lcCell, lcClip, lcClip1, lcClip2, lcType, 	;
			lnClip, lnClipStep, lnCols, lnLines, 	;
			loSheet, 	;
			lu
*: lcSheet - XLS sheet name
*:	lnLine, lnCol - XLS Cell ID. Started copying from this cell.
*: aX - array to copy
*: llClear - logical. If .t. cells from lnLine,lnCol in xls sheet to be cleared before copying.

		lnLines=ALEN(aX,1)
		lnCols=ALEN(aX,2)
		llOneDim = lnCols=0
		lnCols=MAX(1,lnCols)
		FOR i=1 TO lnLines
			FOR j=1 TO lnCols
				lcType=TYPE("aX(i,j)")
				DO CASE
					CASE lcType="N"
						aX(i,j)= TRAN(aX(i,j))
						IF this.lcDecPoint#'.'
							aX(i,j)=CHRTRAN(aX(i,j),'.',this.lcDecPoint)
						ENDIF
					CASE lcType="L"
						aX(i,j)= LANG(IIF(aX(i,j),'','ͳ'),IIF(aX(i,j),'',''))
					CASE lcType="D"
						aX(i,j)= DTOC(aX(i,j))
					CASE lcType="T"
						aX(i,j) = TTOC(aX(i,j))
					CASE ISNULL(aX(i,j))
						aX(i,j)=' '
				ENDCASE
				IF EMPTY(aX(i,j))
					aX(i,j)=' '
				ENDIF
			NEXT
		NEXT
		_CLIPTEXT =press(@aX)
		THIS.PasteRows(lcSheet,lnLine,lnLine+lnLines-1)
		_CLIPTEXT = ''
		RETU
		DIME aX(1)

	FUNCTION CopyRows
		LPARAMETERS loSheet,ln1,ln2

		IF TYPE('loSheet')#'O'
			loSheet=THIS.ActiveSheet()
		ENDIF
		IF TYPE('ln1')='C'
			IF ISDIGIT(CHRTRAN(ln1,':',''))
				ln1='A'+STRTRAN(ln1,':',':'+num2lat(lnLastColumn),1,1)
			ENDIF
			loRange = loSheet.getCellRangeByName(ln1)
		ELSE
			loRange = loSheet.getCellRangeByPosition(0,ln1-1,250,ln2-1)
		ENDIF
		loCtl=THIS.loDocument.getCurrentController()
		loCtl.SELECT(loRange)
		loFrame=loCtl.getFrame()
		DIMENSION  laArgs(1)
		laArgs(1) =THIS.SetProp()
		THIS.loDispatcher.executeDispatch(loCtl, ".uno:Copy", "", 0, @laArgs)

	FUNCTION CopyRowsTo
		LPARAMETERS loSheet,lnFrom1,lnFrom2, lnTo1, lnTo2
* CopyRowsTo(loSheet,lnFrom1,lnFrom2, lnTo1, lnTo2)
		lcTo = ALLTRIM(STR(lnTo1))+':'+ALLTRIM(STR(lnTo2))
		THIS.InsertRows(loSheet,lnTo1,lnTo2)
		lcFrom=ALLTRIM(STR(lnFrom1))+':'+ALLTRIM(STR(lnFrom2))
		THIS.CopyRows(loSheet,lnFrom1,lnFrom2)
		THIS.PasteRows(loSheet,lnTo1, lnTo2)

	FUNCTION CopySheet
		LPARAMETERS loSheet

		IF TYPE('loSheet')#'O'
			loSheet=THIS.loDocument.getCurrentController().getActiveSheet()
		ENDIF
		lcDoc=THIS.loDocument.geturl
		lnPos=RAT('/',lcDoc)
		IF lnPos>0
			lcDoc=SUBSTR(lcDoc,lnPos+1)
		ENDIF

		LOCAL laArgs(3)
		laArgs(1) =THIS.SetProp("DocName",lcDoc,1)
		laArgs(2) =THIS.SetProp("Index",32767,2)
		laArgs(3) =THIS.SetProp("Copy",.T.,3)
		THIS.loDispatcher.executeDispatch(THIS.loDocument.CurrentController.Frame,  ".uno:Move", "", 0, @laArgs)

	FUNCTION CutCopyMode
		LPARAMETERS llMode
		RETU


	FUNCTION DeleteRows
		LPARAMETERS ln1,ln2
		DIMENSION  laArgs(1)
		ln2 = EVL(ln2,ln1)
		laArgs(1) =THIS.SetProp("ToPoint","$A$"+ALLTRIM(STR(ln1))+":$A$"+ALLTRIM(STR(ln2)),1)
		THIS.loDispatcher.executeDispatch(THIS.loDocument.CurrentController.Frame, ".uno:GoToCell", "", 0, @laArgs)

		laArgs(1) =THIS.SetProp("Flags","R",1)
		THIS.loDispatcher.executeDispatch(THIS.loDocument.CurrentController.Frame, ".uno:DeleteCell", "", 0, @laArgs)

	FUNCTION DeleteSheet
		LPARAMETERS lcSheet
		THIS.SetSheetVisible(lcSheet,.F.)
		IF TYPE('lcSheet')='O'
			lcSheet=lcSheet.getName()
		ENDIF
		THIS.SelectSheet(lcSheet)
		LOCAL laArgs(1)
		laArgs(1) =THIS.SetProp()
		THIS.loDispatcher.executeDispatch(THIS.loDocument.CurrentController.Frame, ".uno:Remove", "", 0, @laArgs)


	FUNCTION DisplayAlerts
		LPARAMETERS llDisplay
* ?   
		RETURN .T.


	FUNCTION GetActiveCell
		LPARAMETERS loSheet, llRange
		lo=THIS.loDocument.CurrentSelection
		RETURN IIF(llRange,Range_N2C(lo.CellAddress.ROW+1,lo.CellAddress.COLUMN+1),lo)

		RETURN THIS.loDocument.CurrentSelection

	FUNCTION GetCellFormula
		LPARAMETERS loSheet, lnRow, lnColumn
		loSheet=IIF(TYPE('loSheet')='O',loSheet,THIS.ActiveSheet())
		RETURN loSheet.getCellByPosition(lnColumn-1,lnRow-1).getFormula()

	FUNCTION GetCellValue
		LPARAMETERS loSheet, lnRow, lnColumn
		loSheet=IIF(TYPE('loSheet')='O',loSheet,THIS.ActiveSheet())
		RETURN loSheet.getCellByPosition(lnColumn-1,lnRow-1).getstring()

	FUNCTION GetPaint
		LPARAMETERS loSheet,lnLine1,lnRow1,lnLine2,lnRow2
		loOldSheet=THIS.ActiveSheet()
		loSheet=THIS.SelectSheet(loSheet)
		THIS.SelectRange(loSheet,lnLine1,lnRow1,lnLine2,lnRow2)
		LOCAL laArgs(1)
		laArgs(1) =THIS.SetProp()
		THIS.loDispatcher.executeDispatch(THIS.loDocument.CurrentController.Frame,  ".uno:Copy","" , 0, @laArgs)
		THIS.SelectSheet(loOldSheet)
		RETU


	FUNCTION InsertColumns
		LPARAMETERS loSheet,ln1,ln2
		IF TYPE('loSheet')='C' AND !EMPTY(loSheet)
			loSheet=THIS.loDocument.getSheets.getbyName(loSheet)
		ENDIF
		IF TYPE('loSheet')#'O'
			loSheet=THIS.ActiveSheet()
		ENDIF
		loTargetCell=loSheet.getCellRangeByPosition(ln1,0,ln2,0)
		LOCAL laArgs(1)
		THIS.loDocument.getCurrentController().SELECT(loTargetCell)
		laArgs(1) =THIS.SetProp()
		THIS.loDispatcher.executeDispatch(THIS.loDocument.CurrentController.Frame,  ".uno:InsertColumns", "", 0, @laArgs)


	FUNCTION InsertRight
		LPARAMETERS loSheet,lnLine,lnCol, lnCount
*InsertRight(loSheet,lnLine,lnCol, lnCount)
		IF TYPE('loSheet')='C' AND !EMPTY(loSheet)
			loSheet=THIS.loDocument.getSheets.getbyName(loSheet)
		ENDIF
		IF TYPE('loSheet')='O'
			loSheet=THIS.ActiveSheet()
		ENDIF

		IF TYPE('lnLine')='C'
			loTargetCell=loSheet.getCellRangeByName(lnLine)
		ELSE
			loTargetCell=loSheet.getCellRangeByPosition(lnCol-1,lnLine-1,lnCol+lnCount-1,lnLine-1)
		ENDIF

		THIS.loDocument.getCurrentController().SELECT(loTargetCell)
		LOCAL laArgs(1)
		laArgs(1) =THIS.SetProp("Flags",">",1)
		THIS.loDispatcher.executeDispatch(THIS.loDocument.CurrentController.Frame,  ".uno:InsertCell", "", 0, @laArgs)

	FUNCTION InsertRows
		LPARAMETERS loSheet,ln1,ln2
		IF TYPE('loSheet')='C' AND !EMPTY(loSheet)
			loSheet=THIS.loDocument.getSheets.getbyName(loSheet)
		ENDIF
		IF TYPE('loSheet')#'O'
			loSheet=THIS.ActiveSheet()
		ENDIF
		loTargetCell=loSheet.getCellRangeByPosition(0,ln1-1,0,ln2-1)

		LOCAL laArgs(1)
		THIS.loDocument.getCurrentController().SELECT(loTargetCell)
		laArgs(1) =THIS.SetProp()
		THIS.loDispatcher.executeDispatch(THIS.loDocument.CurrentController.Frame, ".uno:InsertRows", "", 0, @laArgs)

	FUNCTION IsSheetVisible
		LPARAMETERS loSheet
		RETURN loSheet.IsVisible

	FUNCTION LastCell
		LPARAMETERS loSheet, lnRows, lnColumns
		THIS.loDocument.getCurrentController().setActiveSheet(loSheet)
		LOCAL  laArgs(1)
		laArgs(1) =THIS.SetProp("Sel",.F.,1)

		THIS.loDispatcher.executeDispatch(THIS.loDocument.CurrentController.Frame, ".uno:GoToEndOfData", "", 0, @laArgs)
		locell=THIS.loDocument.getCurrentSelection()
		lnRows=locell.getCellAddress.ROW+1
		lnColumns=locell.getCellAddress.COLUMN+1

	FUNCTION NumberFormat
		LPARAMETERS loSheet, lcRange, lcType, lnDecimals
		LOCAL lnFormat, locell
		WITH THIS
			DO CASE
				CASE lcType='C'
					lnFormat = 100
				CASE lcType='N'
					lnFormat=ICASE(lnDecimals=0,1,lnDecimals=2,2,.T.,THIS.NumberFormatStyle('0'+this.lcDecPoint+REPLICATE('0',lnDecimals)))
				OTHERWISE
					RETURN
			ENDCASE
			.SelectRange(loSheet, lcRange)
			locell=.loDocument.getCurrentSelection()
			locell.NumberFormat=lnFormat
		ENDWITH

	FUNCTION NumberFormatStyle
		LPARAMETERS lcFormat, llReturnDecimalPoint
		LOCAL lnFormatNum, loFormats, loLocale
		WITH THIS
			loLocale = THIS.loMgr.Bridge_GetStruct( "com.sun.star.lang.Locale" )
			loFormats = .loDocument.getNumberFormats()
IF llReturnDecimalPoint
this.lcDecPoint=SUBSTR(loFormats.getbykey(2).FormatString,2,1)
RETURN
endif
			lnFormatNum = loFormats.queryKey (lcFormat, loLocale, .T.)
			IF lnFormatNum = -1
				lnFormatNum = loFormats.addNew(lcFormat, loLocale)
			ENDIF
		ENDWITH
		RETURN lnFormatNum

	FUNCTION OpenDocument
		LPARAMETERS lcFile
		LOCAL lc, loProperty
		lcFile=FULLPATH(lcFile)
		IF !FILE(lcFile)
			SAY(lcFile,' ')
			RETURN .F.
		ENDIF
		WITH THIS
			LOCAL laArgs(1)
			laArgs(1) =THIS.SetProp("Hidden",.F.,1)
			.loDocument = .loDesktop.LoadComponentFromURL( THIS.ConvertToURL(lcFile),"_blank",0,@laArgs)
			.GetLocale()
			.SetDocumentVisible(.F.)
		ENDWITH

	FUNCTION PageBreak
		LPARAMETERS loSheet, lnLine
		LOCAL laArgs(1)
		IF TYPE('loSheet')#'O'
			loSheet=THIS.loDocument.getCurrentController().getActiveSheet()
		ENDIF

		THIS.SelectRange(loSheet, lnLine,1, lnLine,1)
		laArgs(1) =THIS.SetProp()
		THIS.loDispatcher.executeDispatch(THIS.loDocument.CurrentController.Frame, ".uno:InsertRowBreak", "", 0, @laArgs)

	FUNCTION PasteCells
		LPARAMETERS loSheet,ln1,ln2
		IF TYPE('loSheet')='C'
			loSheet=THIS.loDocument.getSheets.getbyName(loSheet)
		ENDIF
		IF TYPE('loSheet')#'O'
			loSheet=THIS.ActiveSheet()
		ENDIF
		IF TYPE('ln1')='C'
			IF ISDIGIT(ln1)
				lcRange='A'+STRTRAN(ln1,':',':IV')
			ELSE
				lcRange=ln1
			ENDIF
		ELSE
			lcRange=num2lat(ln2)+ALLTRIM(STR(ln1))
		ENDIF
		THIS.SelectRange(loSheet,lcRange)
		loFrame=THIS.loDocument.getCurrentController().getFrame()
		DIMENSION  laArgs(1)
		laArgs(1) =THIS.SetProp()
		THIS.loDispatcher.executeDispatch(loFrame, ".uno:Paste", "", 0, @laArgs)

	FUNCTION PasteFromArray
		PARAMETERS loSheet,laPasteArray,lnLine1,lnCol1,lnLine2,lnCol2
		LOCAL lcRange
		loSheet=IIF(TYPE('loSheet')#'O',THIS.loDocument.ActiveSheet,loSheet)
		IF TYPE('ln1')='C'
			lcRange=ln1+IIF(':'$ln1,'',':'+Range_C2N(ln1,,,ALEN(laPasteArray,1),ALEN(laPasteArray,2)))
		ELSE
			lcRange=ALLTRIM(STR(ln1))+':'+ALLTRIM(STR(EVL(ln2,ln1)))
		ENDIF
		loSheet.RANGE(lcRange).VALUE=ArrayPasser('laPasteArray')

	FUNCTION PasteRows
		LPARAMETERS loTargetSheet,ln1,ln2
		IF TYPE('loTargetSheet')=='C'
			loTargetSheet=THIS.loDocument.getSheets.getbyName(loTargetSheet)
		ENDIF
		IF TYPE('ln1')='C'
			IF ISDIGIT(ln1)
				lcRange='A'+STRTRAN(ln1,':',':'+num2lat(lnLastColumn))
			ELSE
				lcRange=ln1
			ENDIF
		ELSE
			lcRange='A'+ALLTRIM(STR(ln1))+':'+num2lat(lnLastColumn)+ALLTRIM(STR(ln2))
		ENDIF

		THIS.SelectRange(,lcRange)
		loFrame=THIS.loDocument.getCurrentController().getFrame()
		DIMENSION  laArgs(6)
		laArgs(1) =THIS.SetProp("Flags","A",1)
		laArgs(2) =THIS.SetProp("FormulaCommand",0,2)
		laArgs(3) =THIS.SetProp("SkipEmptyCells",.F.,3)
		laArgs(4) =THIS.SetProp("Transpose",.F.,4)
		laArgs(5) =THIS.SetProp("AsLink",.F.,5)
		laArgs(6) =THIS.SetProp("MoveMode",0,6)
		THIS.loDispatcher.executeDispatch(loFrame, ".uno:InsertContents", "", 0, @laArgs)

	FUNCTION ReadCell
		LPARAMETERS lnSheet,lnCol, lnRow
		RETURN THIS.loDocument.getSheets().getbyindex( lnSheet-1 ).getCellByPosition(lnCol-1, lnRow-1).getText().STRING

	FUNCTION RenameSheet
		LPARAMETERS lcName
		THIS.loDocument.getCurrentController().getActiveSheet().setname(lcName)

	FUNCTION SAVEAS
		LPARAMETERS lcFile
		WITH THIS
			LOCAL laArgs(1)
			laArgs(1) =THIS.SetProp("Overwrite",.T.,1)
			.loDocument.storeAsURL(.ConvertToURL(FULLPATH(lcFile)), @laArgs)
		ENDWITH

	FUNCTION SelectColumn
		LPARAMETERS loSheet,lnColumn
		LOCAL loCol
		loSheet=IIF(TYPE('loSheet')='O',loSheet,THIS.ActiveSheet())
		IF TYPE('lnColumn')='N'
			loCol=loSheet.getColumns().getbyindex(lnColumn-1)
		ELSE
			loCol=loSheet.getColumns().getbyName(lnColumn)
		ENDIF
		THIS.loDocument.getCurrentController().SELECT(loCol)
		RETURN loCol

	FUNCTION SelectRange
*	Call:	SelectRange(loSheet,lnLine1,lnCol1,lnLine2,lnCol2)
		LPARAMETERS loSheet,lnLine1,lnCol1,lnLine2,lnCol2
		IF TYPE('lnLine1')='C'
			IF ISDIGIT(lnLine1)
				lcRange='A'+STRTRAN(lnLine1,':',':IV')
			ELSE
				lcRange=lnLine1
			ENDIF
		ELSE
			lnLine1=EVL(lnLine1,1)
			lnCol1=EVL(lnCol1,1)
			lnLine2=EVL(lnLine2,lnLine1)
			lnCol2=EVL(lnCol2,lnCol1)
TEXT TO lcRange
<<Num2Lat(lnCol1)>><<int(lnLine1)>>:<<Num2Lat(lnCol2)>><<int(lnLine2)>>
ENDTEXT
		ENDIF
		LOCAL laArgs(1)
		laArgs(1) =THIS.SetProp("ToPoint",lcRange)
		THIS.loDispatcher.executeDispatch(THIS.loDocument.CurrentController.Frame, ".uno:GoToCell", "", 0, @laArgs)

	FUNCTION SelectSheet
		LPARAMETERS lcsheetName
		LOCAL lo, lcType
		IF TYPE('lcsheetName')='O'
			lcsheetName=lcsheetName.getName()
		ENDIF
		lcType=TYPE('lcsheetName')
		DO CASE
			CASE lcType = 'N'
				lo=THIS.loDocument.Sheets.getbyindex(lcsheetName-1)
			CASE lcType = 'C'
				lo=THIS.loDocument.Sheets.getbyName(lcsheetName)
			OTHERWISE
				lo=lcsheetName
		ENDCASE
		THIS.loDocument.getCurrentController.setActiveSheet(lo)
		RETURN lo

	FUNCTION SetActiveCell
		LPARAMETERS loSheet, locell
		THIS.loDocument.CurrentController.SELECT(locell)

	FUNCTION SetCellFormula
		LPARAMETERS loSheet, lnRow, lnColumn, luValue
		loSheet=IIF(TYPE('loSheet')='O',loSheet,THIS.ActiveSheet())
		RETURN loSheet.getCellByPosition(lnColumn-1,lnRow-1).setFormula(luValue)

	FUNCTION SetCellValue
		LPARAMETERS loSheet, lnRow, lnColumn, luValue
		loSheet=IIF(TYPE('loSheet')='O',loSheet,THIS.ActiveSheet())
		RETURN loSheet.getCellByPosition(lnColumn-1,lnRow-1).setstring(luValue)

	FUNCTION SetColumnAutoWidth
		LPARAMETERS lnColumn1,lnColumn2
		LOCAL lnCol, loSheet
		loSheet=THIS.ActiveSheet()
		FOR lnCol=lnColumn1 TO EVL(lnColumn2,lnColumn1)
			loSheet.COLUMNS(lnCol).OptimalWidth =.T.
		NEXT
		RETU

	FUNCTION SetColumnWidth
		LPARAMETERS lnColumn, lnWidth, lnKoef
		lnKoef=EVL(lnKoef, 182) && 254

		WITH THIS
			.SelectColumn(THIS.ActiveSheet(),lnColumn)
			LOCAL laArgs(1)
			laArgs(1) =THIS.SetProp("ColumnWidth",INT(lnWidth*lnKoef),1)
			.loDispatcher.executeDispatch(.loDocument.CurrentController.Frame, ".uno:ColumnWidth", "", 0, @laArgs)
		ENDWITH

	FUNCTION SetDocumentVisible
		LPARAMETERS llVisible
		THIS.loDocument.getCurrentController.getFrame.getContainerWindow.setVisible(llVisible)

	FUNCTION SetFontSize
		LPARAMETERS lcRange, lnFontSize
		LOCAL loSheet
		WITH THIS
			loSheet=.ActiveSheet()
			.SelectRange(loSheet, lcRange)
			DIMENSION  laArgs(1)
			laArgs(1) =THIS.SetProp("FontHeight.Height",lnFontSize,1)
			.loDispatcher.executeDispatch(.loDocument.CurrentController.Frame, ".uno:FontHeight", "", 0, @laArgs)
		ENDWITH

	FUNCTION SetPaint
		LPARAMETERS loSheet,lnLine1,lnRow1,lnLine2,lnRow2
		IF TYPE('lnLine1')='C'
			THIS.SelectRange(loSheet,lnLine1)
		ELSE
			THIS.SelectRange(loSheet,lnLine1,lnRow1,lnLine2,lnRow2)
		ENDIF

		LOCAL laArgs(6)
		laArgs(1) =THIS.SetProp("Flags","T",1)
		laArgs(2) =THIS.SetProp("FormulaCommand",0,2)
		laArgs(3) =THIS.SetProp("SkipEmptyCells",.F.,3)
		laArgs(4) =THIS.SetProp("Transpose",.F.,4)
		laArgs(5) =THIS.SetProp("AsLink",.F.,5)
		laArgs(6) =THIS.SetProp("MoveMode",4,6)

		THIS.loDispatcher.executeDispatch(THIS.loDocument.CurrentController.Frame, ".uno:InsertContents", "", 0, @laArgs)
		RETU

	FUNCTION SetProp( lcName, luValue, lnNum )
		lnNum=EVL(lnNum,1)
		WITH THIS
			.laProps(lnNum).NAME = lcName
			.laProps(lnNum).VALUE = luValue
			RETURN .laProps(lnNum)
		ENDWITH

	FUNCTION SetRowAutoHeight
		LPARAMETERS lnRow1,lnRow2
		LOCAL lnRow, loSheet
		loSheet=THIS.ActiveSheet()
		FOR lnRow=lnRow1 TO EVL(lnRow2,lnRow1)
			loSheet.ROWS(lnRow).OptimalHeight =.T.
		NEXT

	FUNCTION SetSheetVisible
		LPARAMETERS loSheet, llVisible
		IF TYPE('loSheet')='C'
			loSheet=THIS.SelectSheet(loSheet)
		ENDIF
		loSheet.IsVisible=llVisible

	FUNCTION SheetName
		LPARAMETERS loSheet
		RETURN loSheet.getName()

	FUNCTION Sheetcount
		RETURN THIS.loDocument.Sheets.COUNT

	FUNCTION WriteCell
		LPARAMETERS lnSheet,lnCol, lnRow, luValue
		loText=THIS.loDocument.getSheets().getbyindex( lnSheet-1 ) .getCellByPosition(lnCol-1, lnRow-1).getText()
		loText.STRING=luValue

	FUNCTION PageOrientation
		LPARAMETERS lnOrientation
		PUBLIC gaArgs(1)
		gaArgs(1) =THIS.SetProp("PaperOrientation",lnOrientation-1,1)
		THIS.loDocument.PRINTER=ArrayPasser('gaArgs')
		RELEASE gaArgs

	FUNCTION GetLocale
		RETURN This.NumberFormatStyle('',.t.)
ENDDEFINE
